Provide grml's gpg key via /etc/grml/fai/files/etc/apt/grml.key
[grml-live.git] / grml-live
index d776c19..50872ac 100755 (executable)
--- a/grml-live
+++ b/grml-live
@@ -4,7 +4,6 @@
 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2 or any later version.
-# Latest change: Die Okt 30 00:09:42 CET 2007 [mika]
 ################################################################################
 
 # read configuration files, set some misc variables {{{
@@ -15,10 +14,61 @@ export LC_ALL=C
 # exit on any error:
 set -e
 
-GRML_LIVE_VERSION='0.0.7'
+GRML_LIVE_VERSION='0.9.6'
+PN="$(basename $0)"
 CMDLINE="$0 $@"
 ISO_DATE="$(date +%Y-%m-%d)"
 
+# usage information {{{
+usage()
+{
+  echo "
+$PN - build process script for generating a (grml based) Linux Live-ISO
+
+Usage: $PN [options, see as follows]
+
+   -a <architecture>       architecture; available values: i386 and amd64
+   -b                      build the ISO without updating the chroot via FAI
+   -c <classe[s]>          classes to be used for building the ISO via FAI
+   -C <configfile>         configuration file for grml-live
+   -F                      force execution without prompting
+   -g <grml_name>]         set the grml flavour name
+   -h                      display short usage information and exit
+   -i <iso_name>           name of ISO
+   -o <output_directory>   main output directory of the build process
+   -r                      release name
+   -s <suite>              Debian suite; values: etch, lenny, sid
+   -t <template_directory> place of the templates
+   -u                      update existing chroot instead of rebuilding it from scratch
+   -v <version_number>     specify version number of the release
+   -V                      increase verbosity in the build process
+   -z                      use ZLIB instead of LZMA compression (depends on
+                           squashfs-tools version)
+
+Usage examples:
+
+    $PN
+    $PN -c GRMLBASE,GRML_MEDIUM,I386 -o /dev/shm/grml
+    $PN -c GRMLBASE,GRML_SMALL,REMOVE_DOCS,I386 -g grml-small -v 1.0
+    $PN -c GRMLBASE,GRML_FULL,I386 -i grml_0.0-1.iso -v 0.0-1
+    $PN -c GRMLBASE,GRML_FULL,I386 -s sid -V -r 'grml-live rocks'
+
+More details: man grml-live + /usr/share/doc/grml-live/grml-live.html
+              http://grml.org/grml-live/
+
+Please send your bug reports and feedback to the grml-team: http://grml.org/bugs/
+"
+}
+
+# make sure it's possible to get usage information without being
+# root or actually executing the script
+if [ "$1" = '-h' -o "$1" = '--help' ] ; then
+   usage
+   [ "$(id -u 2>/dev/null)" != 0 ] && echo "Please notice that this script requires root permissions."
+   exit 0
+fi
+# }}}
+
 # we need root permissions for the build-process:
 if [ "$(id -u 2>/dev/null)" != 0 ] ; then
    echo "Error: please run this script with uid 0 (root)." >&2
@@ -31,6 +81,7 @@ if [ -r /var/run/fai/FAI_INSTALLATION_IN_PROGRESS ] ; then
    exit 1
 fi
 
+# see #449236
 if [ -r /var/run/fai/fai_softupdate_is_running ] ; then
    echo "/usr/sbin/fai softupdate already running or was aborted before.">&2
    echo "You may remove /var/run/fai/fai_softupdate_is_running and try again.">&2
@@ -41,6 +92,8 @@ fi
 VERBOSE=''
 FORCE=''
 UPDATE=''
+BUILD_ONLY=''
+HOSTNAME=''
 
 if [ -r /etc/grml/lsb-functions ] ; then
    . /etc/grml/lsb-functions
@@ -55,18 +108,19 @@ fi
 LIVE_CONF=/etc/grml/grml-live.conf
 . $LIVE_CONF
 
-PN=$(basename $0)
 # }}}
 
 # clean exit {{{
 bailout() {
+  rm -f /var/run/fai/fai_softupdate_is_running \
+        /var/run/fai/FAI_INSTALLATION_IN_PROGRESS
   [ -n "$MIRROR_DIRECTORY" ] && umount "${CHROOT_OUTPUT}/${MIRROR_DIRECTORY}"
   [ -n "$1" ] && EXIT="$1" || EXIT="1"
   [ -n "$2" ] && eerror "$2">&2
   log "------------------------------------------------------------------------------"
   exit "$EXIT"
 }
-trap bailout 1 2 3 15
+trap bailout 1 2 3 3 6 9 14 15
 # }}}
 
 # check for important variables {{{
@@ -87,11 +141,7 @@ if [ -z "$LOGFILE" ] ; then
 fi
 touch $LOGFILE
 chown root:adm $LOGFILE
-chmod 640 $LOGFILE
-# clean/zero logfile:
-if [ -n "$ZERO_LOGFILE" ] ; then
-   echo -n > $LOGFILE
-fi
+chmod 664 $LOGFILE
 
 NFSROOT_CONF=/etc/grml/fai/make-fai-nfsroot.conf
 
@@ -146,41 +196,24 @@ extend_string_end() {
 }
 # }}}
 
-# usage information {{{
-usage()
-{
-  echo "
-$PN - build process script for generating a (grml based) Linux Live-ISO
-
-Usage: $PN [-a <architecture>] [-c <classe[s]>] [-g <grml_name>] \\
-                 [-i <iso_name> ] [-o <output_directory>] [-s <suite>] \\
-                 [-t <template_directory>] [-s <suite>] \\
-                 [-v <version_number>] [-FVhu]
-
-Usage examples:
-
-    $PN
-    $PN -c GRMLBASE,GRML_SMALL,I386 -o /grml/
-    $PN -c GRMLBASE,GRML_MEDIUM,I386 -o /dev/shm/grml
-    $PN -c GRMLBASE,GRML_SMALL,I386 -g grml-small -v 1.0
-    $PN -c GRMLBASE,GRML_FULL,I386 -i grml_0.0-1.iso -v 0.0-1
-    $PN -c GRMLBASE,GRML_FULL,I386 -s sid -V -r 'grml-live rocks'
-
-More details: man grml-live
-              /usr/share/doc/grml-live/grml-live.html
-
-Please send your bug reports, feedback,.. to the grml-team.
-http://grml.org/bugs/
-"
-}
+# read local (non-packaged) configuration {{{
+LOCAL_CONFIG=/etc/grml/grml-live.local
+if [ -r "$LOCAL_CONFIG" ] ; then
+   log "Sourcing $LOCAL_CONFIG"
+   . $LOCAL_CONFIG
+else
+   log "No $LOCAL_CONFIG found, not sourcing it"
+   LOCAL_CONFIG=''
+fi
 # }}}
 
 # command line parsing {{{
-
-while getopts "a:c:g:i:o:r:s:t:v:FhuV" opt; do
+while getopts "a:C:c:g:i:o:r:s:t:v:bFuVz" opt; do
   case "$opt" in
     a) ARCH="$OPTARG" ;;
+    b) BUILD_ONLY=1 ;;
     c) CLASSES="$OPTARG" ;;
+    C) CONFIG="$OPTARG" ;;
     g) GRML_NAME="$OPTARG" ;;
     i) ISO_NAME="$OPTARG" ;;
     o) OUTPUT="$OPTARG"
@@ -193,9 +226,9 @@ while getopts "a:c:g:i:o:r:s:t:v:FhuV" opt; do
     t) TEMPLATE_DIRECTORY="$OPTARG";;
     v) VERSION="$OPTARG" ;;
     F) FORCE=1 ;;
-    h) usage ; bailout 0 ;;
     u) UPDATE=1 ;;
     V) VERBOSE="-v" ;;
+    z) SQUASHFS_ZLIB="-nolzma" ;;
     ?) echo "invalid option -$OPTARG" >&2; bailout 1 ;;
   esac
 done
@@ -207,6 +240,33 @@ shift $(($OPTIND - 1))  # set ARGV to the first not parsed commandline parameter
 specify it on the command line using the -c option."
 [ -n "$OUTPUT" ] || bailout 1 "Error: \$OUTPUT unset, please set it in $LIVE_CONF or
 specify it on the command line using the -o option."
+
+# trim characters that are known to cause problems inside $GRML_NAME;
+# for example isolinux does not like '-' inside the directory name
+[ -n "$GRML_NAME" ] && export SHORT_GRML_NAME="$(echo $GRML_NAME | tr -d ',./;\- ')"
+
+# export variables to have them available in fai scripts:
+[ -n "$GRML_NAME" ]   && export GRML_NAME="$GRML_NAME"
+[ -n "$RELEASENAME" ] && export RELEASENAME="$RELEASENAME"
+# }}}
+
+# clean/zero grml-live logfile {{{
+if [ -n "$ZERO_LOGFILE" ] ; then
+   echo -n > $LOGFILE
+fi
+# }}}
+
+# clean/zero/remove old FAI directory {{{
+if [ -n "$ZERO_FAI_LOGFILE" ] ; then
+   if [ -d /var/log/fai/"$HOSTNAME" ] ; then
+      rm -rf /var/log/fai/"$HOSTNAME"/"$(readlink /var/log/fai/"$HOSTNAME"/last)"
+      rm -rf /var/log/fai/"$HOSTNAME"/"$(readlink /var/log/fai/"$HOSTNAME"/last-dirinstall)"
+      rm -rf /var/log/fai/"$HOSTNAME"/"$(readlink /var/log/fai/"$HOSTNAME"/last-softupdate)"
+      rm -f /var/log/fai/"$HOSTNAME"/last \
+            /var/log/fai/"$HOSTNAME"/last-dirinstall \
+            /var/log/fai/"$HOSTNAME"/last-softupdate
+   fi
+fi
 # }}}
 
 # ask user whether the setup is ok {{{
@@ -215,6 +275,8 @@ if [ -z "$FORCE" ] ; then
    echo "${PN} [${GRML_LIVE_VERSION}]: check your configuration (or use -F to force execution):"
    echo
    echo "  FAI classes:       $CLASSES"
+   [ -r "$LOCAL_CONFIG" ]  && echo "  local config:      /etc/grml/grml-live.local"
+   [ -n "$CONFIG" ]        && echo "  configuration:     $CONFIG"
    echo "  main directory:    $OUTPUT"
    [ -n "$CHROOT_OUTPUT" ] && echo "  chroot target:     $CHROOT_OUTPUT"
    [ -n "$BUILD_OUTPUT" ]  && echo "  build target:      $BUILD_OUTPUT"
@@ -228,8 +290,11 @@ if [ -z "$FORCE" ] ; then
    [ -n "$TEMPLATE_DIRECTORY" ] && echo "  Template files:    $TEMPLATE_DIRECTORY"
    [ -n "$FAI_ARGS" ]      && echo "  additional arguments for FAI: $FAI_ARGS"
    [ -n "$LOGFILE" ]       && echo "  Logging to file:   $LOGFILE"
+   [ -n "$SQUASHFS_ZLIB" ] && echo "  Using ZLIB (instead of LZMA) compression."
+   [ -n "$SQUASHFS_OPTIONS" ] && echo "  Using SQUASHFS_OPTIONS ${SQUASHFS_OPTIONS}"
    [ -n "$VERBOSE" ]       && echo "  Using VERBOSE mode."
    [ -n "$UPDATE" ]        && echo "  Executing UPDATE instead of fresh installation."
+   [ -n "$BUILD_ONLY" ]    && echo "  Executing BUILD_ONLY instead of fresh installation or UPDATE."
    echo
    echo -n "Is this ok for you? [y/N] "
    read a
@@ -239,10 +304,22 @@ if [ -z "$FORCE" ] ; then
    echo
 fi
 
+if [ -n "$CONFIG" ] ; then
+   if ! [ -f "$CONFIG" ] ; then
+      log "Sorry, $CONFIG could not be read. Exiting. [$(date)]"
+      eerror "Sorry, $CONFIG could not be read. Exiting."
+      bailout 1
+   else
+      log "Sourcing $CONFIG"
+      . $CONFIG
+   fi
+fi
+
 start_seconds=$(cut -d . -f 1 /proc/uptime)
 log "------------------------------------------------------------------------------"
 log "Starting grml-live [${GRML_LIVE_VERSION}] run on $(date)"
-log "Executed command line: $CMDLINE"
+log "Executed grml-live command line:"
+log "$CMDLINE"
 
 einfo "Logging actions to logfile $LOGFILE"
 # }}}
@@ -268,10 +345,15 @@ fi
 
 # does this suck? YES!
 if [ -n "$SUITE" ] ; then
-   sed -i "s/SUITE=.*/SUITE=\"$SUITE\"/" $LIVE_CONF
 
-   DIST="\|\ etch\ \|\ stable\ \|\ lenny\ \|\ testing\ \|\ sid\ \|\ unstable\ "
-   sed -i "s/\(deb .\+\)\([ \t]+\)$DIST\([ \t]+\)\(main \)/\1\2 $SUITE \3\4/" $LIVE_CONF
+   for file in "$LIVE_CONF" "$CONFIG" "$LOCAL_CONFIG" ; do
+       if [ -n "$file" ] ; then
+          sed -i "s/SUITE=.*/SUITE=\"$SUITE\"/" $LIVE_CONF
+          DIST="\|\ etch\ \|\ stable\ \|\ lenny\ \|\ testing\ \|\ sid\ \|\ unstable\ "
+          sed -i "s/\(deb .\+\)\([ \t]+\)$DIST\([ \t]+\)\(main \)/\1\2 $SUITE \3\4/" $file
+       fi
+   done
+
    sed -i "s/\(deb .\+\)\([ \t]+\)$DIST\([ \t]+\)\(main \)/\1\2 $SUITE \3\4/" /etc/grml/fai/apt/sources.list
    # notice: activate grml-live pool only if we are building against unstable:
    if grep -qe unstable -qe sid /etc/grml/fai/apt/sources.list ; then
@@ -283,7 +365,11 @@ if [ -n "$SUITE" ] ; then
       sed -i 's/.*grml-live.*/# removed grml-live repository/' /etc/grml/fai/apt/sources.list
    fi
 
-   sed -i "s|FAI_DEBOOTSTRAP=\"[a-z]* |FAI_DEBOOTSTRAP=\"$SUITE |" $LIVE_CONF
+   for file in "$LIVE_CONF" "$CONFIG" "$LOCAL_CONFIG" ; do
+       if [ -n "$file" ] ; then
+          sed -i "s|FAI_DEBOOTSTRAP=\"[a-z]* |FAI_DEBOOTSTRAP=\"$SUITE |" "$file"
+       fi
+   done
    sed -i "s|FAI_DEBOOTSTRAP=\"[a-z]* |FAI_DEBOOTSTRAP=\"$SUITE |" $NFSROOT_CONF
 fi
 
@@ -299,57 +385,85 @@ fi
 # CHROOT_OUTPUT - execute FAI {{{
 [ -n "$CHROOT_OUTPUT" ] || CHROOT_OUTPUT="$OUTPUT/grml_chroot"
 
-if [ -n "$UPDATE" ] ; then
+if [ -n "$UPDATE" -o -n "$BUILD_ONLY" ] ; then
    FAI_ACTION=softupdate
 else
    FAI_ACTION=dirinstall
 fi
 
-if [ -n "$UPDATE" ] ; then
+if [ -n "$UPDATE" -o -n "$BUILD_ONLY" ] ; then
    if ! [ -r "$CHROOT_OUTPUT/etc/grml_version" ] ; then
-      log "Error: It does not look like you have a working chroot system. Updating not possible."
-      eerror "Error: It does not look like you have a working chroot system. Updating not possible."
+      log "Error: does not look like you have a working chroot. Updating/building not possible."
+      eerror "Error: does not look like you have a working chroot. Updating/building not possible. (Drop -u/-b option?)"
       eend 1
       bailout 20
    fi
 fi
 
-if [ -d "$CHROOT_OUTPUT/bin" -a -z "$UPDATE" ] ; then
+if [ -d "$CHROOT_OUTPUT/bin" -a -z "$UPDATE" -a -z "$BUILD_ONLY" ] ; then
    log "$CHROOT_OUTPUT exists already, skipping stage 'fai dirinstall'"
    ewarn "$CHROOT_OUTPUT exists already, skipping stage 'fai dirinstall'" ; eend 0
 else
    mkdir -p "$CHROOT_OUTPUT" || bailout 5 "Problem with creating $CHROOT_OUTPUT for FAI"
+
    if [ -n "${MIRROR_DIRECTORY}" ] ; then
       mkdir -p "${CHROOT_OUTPUT}/${MIRROR_DIRECTORY}"
       mount --bind "${MIRROR_DIRECTORY}" "${CHROOT_OUTPUT}/${MIRROR_DIRECTORY}"
    fi
-   fai $VERBOSE -C "$GRML_FAI_CONFIG" -c"$CLASSES" -u "$HOSTNAME" $FAI_ACTION "$CHROOT_OUTPUT" $FAI_ARGS | tee -a $LOGFILE
-   log "Setting /etc/grml_version to $GRML_NAME $VERSION Release Codename $RELEASENAME [$ISO_DATE]"
-   echo "$GRML_NAME $VERSION Release Codename $RELEASENAME [$ISO_DATE]" > $CHROOT_OUTPUT/etc/grml_version
-   chmod 644 $CHROOT_OUTPUT/etc/grml_version
+
+   log "Executed FAI command line:"
+   log "BUILD_ONLY=$BUILD_ONLY fai $VERBOSE -C $GRML_FAI_CONFIG -c$CLASSES -u $HOSTNAME $FAI_ACTION $CHROOT_OUTPUT $FAI_ARGS"
+   BUILD_ONLY="$BUILD_ONLY" fai $VERBOSE -C "$GRML_FAI_CONFIG" -c"$CLASSES" -u \
+   "$HOSTNAME" $FAI_ACTION "$CHROOT_OUTPUT" $FAI_ARGS | tee -a $LOGFILE
+   RC="$PIPESTATUS" # notice: bash-only
+
+   if [ "$RC" != 0 ] ; then
+      log "Error while executing fai [exit code ${RC}]. Exiting."
+      eerror "Error while executing fai [exit code ${RC}]. Exiting." ; eend 1
+      bailout 1
+   else
+      log "Setting /etc/grml_version to $GRML_NAME $VERSION Release Codename $RELEASENAME [$ISO_DATE]"
+      echo "$GRML_NAME $VERSION Release Codename $RELEASENAME [$ISO_DATE]" > $CHROOT_OUTPUT/etc/grml_version
+      chmod 644 $CHROOT_OUTPUT/etc/grml_version
+      einfo "Rebuilding initramfs"
+      # make sure new /etc/grml_version reaches the initramfs:
+      chroot $CHROOT_OUTPUT update-initramfs -u -t
+      eend $?
+   fi
+
+   # Remove all FAI logs from chroot if class RELEASE is used:
+   if [ -f "$CHROOT_OUTPUT"/etc/grml_fai_release ] ; then
+      rm -rf "$CHROOT_OUTPUT"/var/log/fai/*
+   fi
+
+   # make sure we don't leave any mounts - FAI doesn't remove them always
    umount $CHROOT_OUTPUT/proc 2>/dev/null || /bin/true
    umount $CHROOT_OUTPUT/sys  2>/dev/null || /bin/true
+   umount $CHROOT_OUTPUT/dev/pts 2>/dev/null || /bin/true
+   umount $CHROOT_OUTPUT/dev 2>/dev/null || /bin/true
+
    [ -n "$MIRROR_DIRECTORY" ] && umount "${CHROOT_OUTPUT}/${MIRROR_DIRECTORY}"
 
    # notice: 'fai dirinstall' does not seem to exit appropriate, so:
    ERROR=''
-   if [ -r "/var/log/fai/dirinstall/$HOSTNAME/software.log" ] ; then
+   CHECKLOG=/var/log/fai/$HOSTNAME/last
+   if [ -r "$CHECKLOG/software.log" ] ; then
       # 1 errors during executing of commands
-      # Unable to write mmap - msync (28 No space left on device)
-      # 'No candidate version found for' [/var/log/fai/current/software.log]
-      grep 'dpkg: error processing' /var/log/fai/dirinstall/$HOSTNAME/software.log >> $LOGFILE && ERROR=1
-      grep 'E: Method http has died unexpectedly!' /var/log/fai/dirinstall/$HOSTNAME/software.log >> $LOGFILE && ERROR=2
-      grep 'ERROR: chroot' /var/log/fai/dirinstall/$HOSTNAME/software.log >> $LOGFILE && ERROR=3
+      grep 'dpkg: error processing' $CHECKLOG/software.log >> $LOGFILE && ERROR=1
+      grep 'E: Method http has died unexpectedly!' $CHECKLOG/software.log >> $LOGFILE && ERROR=2
+      grep 'ERROR: chroot' $CHECKLOG/software.log >> $LOGFILE && ERROR=3
+      grep 'E: Failed to fetch' $CHECKLOG/software.log >> $LOGFILE && ERROR=4
+      grep 'Unable to write mmap - msync (28 No space left on device)' $CHECKLOG/software.log >> $LOGFILE && ERROR=5
    fi
 
-   if [ -r "/var/log/fai/dirinstall/$HOSTNAME/shell.log" ] ; then
-      grep 'FAILED with exit code' /var/log/fai/dirinstall/$HOSTNAME/shell.log >> $LOGFILE && ERROR=2
+   if [ -r "$CHECKLOG/shell.log" ] ; then
+      grep 'FAILED with exit code' $CHECKLOG/shell.log >> $LOGFILE && ERROR=2
    fi
 
    if [ -n "$ERROR" ] ; then
       log "There was an error [${ERROR}] during execution of stage 'fai dirinstall' [$(date)]"
       eerror "There was an error during execution of stage 'fai dirinstall'"
-      echo "   Check out /var/log/fai/dirinstall/$HOSTNAME/ for details. [exit ${ERROR}]"
+      echo "   Check out ${CHECKLOG}/ for details. [exit ${ERROR}]"
       eend 1
       bailout 1
    else
@@ -365,29 +479,39 @@ mkdir -p "$BUILD_OUTPUT" || bailout 6 "Problem with creating $BUILD_OUTPUT for s
 
 # i386:
 if [ "$ARCH" = i386 ] || [ "$ARCH" = amd64 ] ; then
-   if [ -d "$BUILD_OUTPUT"/boot -a -z "$UPDATE" ] ; then
+   if [ -d "$BUILD_OUTPUT"/boot -a -z "$UPDATE" -a -z "$BUILD_ONLY" ] ; then
       log "$BUILD_OUTPUT/boot exists already, skipping stage 'boot'"
       ewarn "$BUILD_OUTPUT/boot exists already, skipping stage 'boot'" ; eend 0
    else
       # booting stuff:
       [ -d "$BUILD_OUTPUT"/boot/isolinux ] || mkdir -p "$BUILD_OUTPUT"/boot/isolinux
-      cp /boot/memtest86+.bin "$BUILD_OUTPUT"/boot/isolinux/memtest
+      [ -d "$BUILD_OUTPUT"/boot/"${SHORT_GRML_NAME}" ] || mkdir -p "$BUILD_OUTPUT"/boot/"${SHORT_GRML_NAME}"
+
+      if [ -z "$NO_ADDONS" ] ; then
+         [ -d "$BUILD_OUTPUT"/boot/addons   ] || mkdir -p "$BUILD_OUTPUT"/boot/addons
+         cp /boot/memtest86+.bin "$BUILD_OUTPUT"/boot/addons/memtest
+      fi
 
       # if we don't have an initrd we a) can't boot and b) there was an error
       # during build, so check for the file:
-      if [ -f "$CHROOT_OUTPUT"/boot/initrd* ] ; then
-         cp "$CHROOT_OUTPUT"/boot/initrd*  "$BUILD_OUTPUT"/boot/isolinux/initrd.gz
+      INITRD="$(ls $CHROOT_OUTPUT/boot/initrd* 2>/dev/null| grep -v '.bak$' | sort -r | head -1)"
+      if [ -n "$INITRD" ] ; then
+         cp $INITRD "$BUILD_OUTPUT"/boot/"${SHORT_GRML_NAME}"/initrd.gz
+         find $CHROOT_OUTPUT/boot/ -name initrd\*.bak -exec rm {} \;
       else
          log "No initrd found inside $CHROOT_OUTPUT/boot/ - Exiting"
          eerror "No initrd found inside $CHROOT_OUTPUT/boot/ - Exiting" ; eend 1
          bailout 10
       fi
 
-      cp "$CHROOT_OUTPUT"/boot/vmlinuz*  "$BUILD_OUTPUT"/boot/isolinux/linux26
-      cp /usr/lib/syslinux/chain.c32     "$BUILD_OUTPUT"/boot/isolinux/
-      cp /usr/lib/syslinux/isolinux.bin  "$BUILD_OUTPUT"/boot/isolinux/
-      cp /usr/lib/syslinux/memdisk       "$BUILD_OUTPUT"/boot/isolinux/
-      cp /usr/lib/syslinux/menu.c32      "$BUILD_OUTPUT"/boot/isolinux/
+      KERNEL_IMAGE="$(ls $CHROOT_OUTPUT/boot/vmlinuz* 2>/dev/null | sort -r | head -1)"
+      if [ -n "$KERNEL_IMAGE" ] ; then
+         cp "$KERNEL_IMAGE" "$BUILD_OUTPUT"/boot/"${SHORT_GRML_NAME}"/linux26
+      else
+         log "No kernel found inside $CHROOT_OUTPUT/boot/ - Exiting"
+         eerror "No kernel found inside $CHROOT_OUTPUT/boot/ - Exiting" ; eend 1
+         bailout 11
+      fi
 
       [ -n "$TEMPLATE_DIRECTORY" ] || TEMPLATE_DIRECTORY='/usr/share/grml-live/templates'
       if ! [ -d "${TEMPLATE_DIRECTORY}"/boot ] ; then
@@ -397,7 +521,10 @@ if [ "$ARCH" = i386 ] || [ "$ARCH" = amd64 ] ; then
       fi
 
       cp ${TEMPLATE_DIRECTORY}/boot/isolinux/*  "$BUILD_OUTPUT"/boot/isolinux/
-      cp ${TEMPLATE_DIRECTORY}/boot/isolinux/*  "$BUILD_OUTPUT"/boot/isolinux/
+
+      if [ -z "$NO_ADDONS" ] ; then
+         cp ${TEMPLATE_DIRECTORY}/boot/addons/*    "$BUILD_OUTPUT"/boot/addons/
+      fi
 
       if ! [ -d "${BUILD_OUTPUT}/boot/grub" ] ; then
          cp -a ${TEMPLATE_DIRECTORY}/boot/grub  "$BUILD_OUTPUT"/boot/
@@ -423,11 +550,23 @@ if [ "$ARCH" = i386 ] || [ "$ARCH" = amd64 ] ; then
       sed -i "s/%RELEASE_INFO%/$RELEASE_INFO/" "$BUILD_OUTPUT"/boot/isolinux/boot.msg
       sed -i "s/%DATE%/$ISO_DATE/"             "$BUILD_OUTPUT"/boot/isolinux/boot.msg
 
+      sed -i "s/%GRML_NAME%/$SHORT_GRML_NAME/" "$BUILD_OUTPUT"/boot/isolinux/isolinux.cfg
+      sed -i "s/%GRML_NAME%/$SHORT_GRML_NAME/" "$BUILD_OUTPUT"/boot/isolinux/syslinux.cfg
+
       sed -i "s/%RELEASE_INFO%/$RELEASE_INFO/" "$BUILD_OUTPUT"/boot/isolinux/boot-beep.msg
       sed -i "s/%DATE%/$ISO_DATE/"             "$BUILD_OUTPUT"/boot/isolinux/boot-beep.msg
 
       sed -i "s/%VERSION%/$VERSION/"           "$BUILD_OUTPUT"/boot/grub/menu.lst
-      sed -i "s/%GRML_NAME%/$GRML_NAME/"       "$BUILD_OUTPUT"/boot/grub/menu.lst
+      sed -i "s/%GRML_NAME%/$SHORT_GRML_NAME/" "$BUILD_OUTPUT"/boot/grub/menu.lst
+
+      # make sure the squashfs filename is set accordingly:
+      GRML_NAME_SQUASHFS="$GRML_NAME.squashfs"
+      sed -i "s/%GRML_NAME_SQUASHFS%/$GRML_NAME_SQUASHFS/" "$BUILD_OUTPUT"/boot/isolinux/isolinux.cfg
+      sed -i "s/%GRML_NAME_SQUASHFS%/$GRML_NAME_SQUASHFS/" "$BUILD_OUTPUT"/boot/isolinux/syslinux.cfg
+
+      GRML_NAME_SQUASHFS="$(cut_string 20 "$GRML_NAME_SQUASHFS")"
+      GRML_NAME_SQUASHFS="$(extend_string_end 20 "$GRML_NAME_SQUASHFS")"
+      sed -i "s/%GRML_NAME_SQUASHFS%/$GRML_NAME_SQUASHFS/" "$BUILD_OUTPUT"/boot/isolinux/f4
 
       # autostart for Windows:
       if [ -d "${TEMPLATE_DIRECTORY}/windows/autostart/" ] ; then
@@ -445,6 +584,7 @@ if [ "$ARCH" = i386 ] || [ "$ARCH" = amd64 ] ; then
                ( cd "$BUILD_OUTPUT"/windows
                  for file in pageant plink pscp psftp putty puttygen ; do
                     wget -O ${file}.exe ${WINDOWS_BINARIES}/${file}.exe
+                    md5sum ${file}.exe > ${file}.exe.md5
                  done )
             fi
          fi
@@ -461,14 +601,61 @@ else
    eerror 'Error: Unsupported ARCH, sorry. Want to support it? Contribute!' ; eend 1
 fi
 
-if [ -f "$BUILD_OUTPUT"/live/grml.squashfs -a -z "$UPDATE" ] ; then
+if [ -f "$BUILD_OUTPUT"/live/${GRML_NAME}.squashfs -a -z "$UPDATE" -a -z "$BUILD_ONLY" ] ; then
    log "$BUILD_OUTPUT/live exists already, skipping stage 'squashfs'"
    ewarn "$BUILD_OUTPUT/live exists already, skipping stage 'squashfs'" ; eend 0
 else
-   mkdir "$BUILD_OUTPUT"/live
-   mksquashfs $CHROOT_OUTPUT/* $BUILD_OUTPUT/live/grml.squashfs -noappend
-   log "Finished execution of stage 'squashfs' [$(date)]"
-   einfo "Finished execution of stage 'squashfs'" ; eend 0
+   [ -d "$BUILD_OUTPUT"/live ] || mkdir "$BUILD_OUTPUT"/live
+   # make sure we don't leave (even an empty) base.tgz:
+   [ -f "$CHROOT_OUTPUT/base.tgz" ] && rm -f "$CHROOT_OUTPUT/base.tgz"
+
+   # make sure mksquashfs can handle the according option:
+   if [ -n "$SQUASHFS_ZLIB" ] ; then
+      mksquashfs --help 2>&1 | grep -q -- "$SQUASHFS_ZLIB" || SQUASHFS_ZLIB=''
+   fi
+
+   if echo "$SQUASHFS_OPTIONS" | grep -q -- "-nolzma" ; then
+      if ! mksquashfs --help 2>&1 | grep -q -- '-nolzma' ; then
+         ewarn "mksquashfs does NOT support the nolzma option, just using default zlib mode."
+         SQUASHFS_OPTIONS="$(echo $SQUASHFS_OPTIONS | sed 's/-nolzma//g')"
+         eend 0
+      fi
+   fi
+
+   if echo "$SQUASHFS_OPTIONS" | grep -q -- "-lzma" ; then
+      if ! mksquashfs --help 2>&1 | grep -q -- '-lzma' ; then
+         ewarn "mksquashfs does NOT support the lzma option, falling back to zlib mode."
+         SQUASHFS_OPTIONS="$(echo $SQUASHFS_OPTIONS | sed 's/-lzma//g')"
+         eend 0
+      fi
+   fi
+
+   # support exclusion of files via exclude-file:
+   if [ -n "$SQUASHFS_EXCLUDES_FILE" -a "$SQUASHFS_EXCLUDES_FILE" ] ; then
+      SQUASHFS_OPTIONS="$SQUASHFS_OPTIONS -ef $SQUASHFS_EXCLUDES_FILE"
+   fi
+
+   # get rid of unnecessary files when building grml-small for final release:
+   if echo "$CLASSES" | grep -q GRML_SMALL ; then
+      SQUASHFS_OPTIONS="$SQUASHFS_OUTPUT -e initrd.img* vmlinuz*"
+   fi
+
+   SQUASHFS_OUTPUT="$(mktemp -t grml-live.XXXXXX)"
+   log "mksquashfs $CHROOT_OUTPUT/* $BUILD_OUTPUT/live/${GRML_NAME}.squashfs -noappend $SQUASHFS_OPTIONS $SQUASHFS_ZLIB"
+   if mksquashfs $CHROOT_OUTPUT/* $BUILD_OUTPUT/live/"${GRML_NAME}".squashfs \
+      -noappend $SQUASHFS_OPTIONS $SQUASHFS_ZLIB 2>"${SQUASHFS_OUTPUT}" ; then
+      echo "${GRML_NAME}.squashfs" > $BUILD_OUTPUT/live/filesystem.module
+      log "Finished execution of stage 'squashfs' [$(date)]"
+      einfo "Finished execution of stage 'squashfs'" ; eend 0
+      rm -f "${SQUASHFS_OUTPUT}"
+   else
+      log "There was an error executing stage 'squashfs' [$(date)]:"
+      log "$(cat $SQUASHFS_OUTPUT)"
+      eerror "There was an error executing stage 'squashfs':" ; eend 1
+      cat "${SQUASHFS_OUTPUT}"
+      rm -f "${SQUASHFS_OUTPUT}"
+      bailout
+   fi
 fi
 
 # create md5sum file:
@@ -486,18 +673,32 @@ elif [ "$BOOT_METHOD" = "grub" ] ; then
    BOOT_FILE="boot/grub/stage2_eltorito"
 fi
 
-if [ -f "${ISO_OUTPUT}/${ISO_NAME}" -a -z "$UPDATE" ] ; then
+if [ -f "${ISO_OUTPUT}/${ISO_NAME}" -a -z "$UPDATE" -a -z "$BUILD_ONLY" ] ; then
    log "$ISO_OUTPUT exists already, skipping stage 'iso build'"
    ewarn "$ISO_OUTPUT exists already, skipping stage 'iso build'" ; eend 0
 else
    mkdir -p "$ISO_OUTPUT" || bailout 6 "Problem with creating $ISO_OUTPUT for stage 'iso build'"
+
    CURRENT_DIR=$(pwd)
-   cd "$BUILD_OUTPUT" &&
-   mkisofs -V "grml $VERSION" -publisher 'grml-live | grml.org' \
-           -l -r -J -no-emul-boot -boot-load-size 4 -boot-info-table    \
-           -b $BOOT_FILE \
-           -o "${ISO_OUTPUT}/${ISO_NAME}" . ; RC=$?
-   cd $CURRENT_DIR
+   if cd "$BUILD_OUTPUT" ; then
+      log "mkisofs -V 'grml $VERSION' -publisher 'grml-live | grml.org' -l -r -J -no-emul-boot -boot-load-size 4 -boot-info-table -b $BOOT_FILE -o ${ISO_OUTPUT}/${ISO_NAME} ."
+      mkisofs -V "grml $VERSION" -publisher 'grml-live | grml.org' \
+              -l -r -J -no-emul-boot -boot-load-size 4 -boot-info-table    \
+              -b $BOOT_FILE \
+              -o "${ISO_OUTPUT}/${ISO_NAME}" . ; RC=$?
+
+      # generate md5sum of ISO if we are using class 'RELEASE':
+      case $CLASSES in *RELEASE*)
+         [ "$RC" = 0 ] && \
+         ( cd $ISO_OUTPUT && \
+         md5sum ${ISO_NAME} > ${ISO_NAME}.md5 && \
+         touch -r ${ISO_NAME} ${ISO_NAME}.md5 )
+         ;;
+      esac
+
+      cd $CURRENT_DIR
+   fi
+
    if [ "$RC" = 0 ] ; then
       log "Finished execution of stage 'iso build' [$(date)]"
       einfo "Finished execution of stage 'iso build'" ; eend 0